START:
Rem CHIP-8 Disassembler written in MMBASIC
Rem Copyright (c) 2012 by Bob Devries
Do
       Cls : Locate 40,150 : Print "CHIP-8 Disassembler (c) 2012 by Bob Devries"
       Locate 40,165 : Print Space$(70)
       Locate 40,165
       Print "Please type CHIP-8 Binary filename (or ENTER to exit) ";
       Line Input fn$
       If fn$ = "" Then Exit
       Open fn$ For input As #1
       If MM.Errno <> 0 Then Print "Error opening input file." : Exit
       fo = Instr(1,fn$,".")
       If fo = 0 Then
              fo$ = fn$ + ".ch8"
       Else
              fo$ = Left$(fn$,fo-1) + ".ch8"
       EndIf
       Locate 40,180 : Print "Output to screen or file?"
       Locate 40,195 : Print "Press 'S' or 'F'"
keyloop: k$ = Inkey$ : If k$ = "" Then GoTo keyloop
       k$ = UCase$(k$)
       If k$ <> "S" And k$ <> "F" GoTo keyloop
       If k$ = "S" Then dev = 0 Else dev = 2
       If k$ = "F" Then Locate 40,210 : Print "Output filename will be ";fo$
       If dev <> 0 Then
              Open fo$ For output As #dev
       EndIf
       If MM.Errno <> 0 Then Print "Error opening output file." : Exit
       addr = &h01FE
       Do While Not(Eof(#1))
              w1 = Asc(Input$(1,#1))
              w2 = Asc(Input$(1,#1))
              word = w1 * 256 + w2 : Rem make it decimal
              whex$ = Hex$(word) : Rem make it hex
              whex$ = "000" + whex$ : Rem we want leading zeroes
              whex$ = Right$(whex$,4) : Rem but just 4 chars
              lhex = Val("&H" + Left$(whex$,1))
              addr = addr + 2
              hexaddr$ = Right$("0000" + Hex$(addr),4)
              If lhex = 0 Then GoSub zero : GoTo cont
              If lhex = 1 Then GoSub one : GoTo cont
              If lhex = 2 Then GoSub two : GoTo cont
              If lhex = 3 Then GoSub three : GoTo cont
              If lhex = 4 Then GoSub four : GoTo cont
              If lhex = 5 Then GoSub five : GoTo cont
              If lhex = 6 Then GoSub six : GoTo cont
              If lhex = 7 Then GoSub seven : GoTo cont
              If lhex = 8 Then GoSub eight : GoTo cont
              If lhex = 9 Then GoSub nine : GoTo cont
              If lhex = 10 Then GoSub ten : GoTo cont
              If lhex = 11 Then GoSub eleven : GoTo cont
              If lhex = 12 Then GoSub twelve : GoTo cont
              If lhex = 13 Then GoSub thirteen : GoTo cont
              If lhex = 14 Then GoSub fourteen : GoTo cont
              If lhex = 15 Then GoSub fifteen : GoTo cont
cont:         Pause 100
       Loop
       If dev = 2 Then
              Close #dev
       EndIf
       Close #1
       Print "Files closed"
       Print "Press ENTER";: Input k$
Loop
Cls : Locate 40,150 : Print "CHIP-8 Disassembler"
Locate 40,165 : Print "End run. Goodbye!"
End

zero: Rem 0XXX
       If whex$ = "0000" Then Print #dev,hexaddr$;": ";whex$;" : NOP" : Return
       If whex$ = "00E0" Then Print #dev,hexaddr$;": ";whex$;" : ERASE" : Return
       If whex$ = "00EE" Then Print #dev,hexaddr$;": "whex$;" : RETURN" : Return
       MMM$ = Right$(whex$,3)
       If Val("&H"+MMM$) < &H200 Then
               Print #dev,hexaddr$;": ";whex$;" : Unknown code" : Return
       EndIf
       Print #dev,hexaddr$;": ";whex$;" : CALL(M/C) $";MMM$
       Return
one: Rem 1MMM
       MMM$ = Right$(whex$,3)
       Print #dev,hexaddr$;": ";whex$;" : GOTO $";MMM$
       Return
two: Rem 2MMM
       MMM$ = Right$(whex$,3)
       Print #dev,hexaddr$;": ";whex$;" : DO $";MMM$
       Return
three: Rem 3XXX
       vx$ = Mid$(whex$,2,1) : kk$ = Right$(whex$,2)
       Print #dev,hexaddr$;": ";whex$;" : SKF V";vx$;" = $";kk$
       Return
four: Rem 4XXX
       vx$ = Mid$(whex$,2,1) : kk$ = Right$(whex$,2)
       Print #dev,hexaddr$;": ";whex$;" : SKF V";vx$;" <> $";kk$
       Return
five: Rem 5XXX
       vx$ = Mid$(whex$,2,1) : vy$ = Mid$(whex$,3,1)
       Print #dev,hexaddr$;": ";whex$;" : SKF V";vx$;" = V";vy$
       Return
six: Rem 6XKK
       vx$ = Mid$(whex$,2,1) : kk$ = Right$(whex$,2)
       Print #dev,hexaddr$;": ";whex$;" : V";vx$;" = $";kk$
       Return
seven: Rem 7XXX
       vx$ = Mid$(whex$,2,1) : kk$ = Right$(whex$,2)
       Print #dev,hexaddr$;": ";whex$;" : V";vx$;" = V";vx$;" + $";kk$
       Return
eight: Rem 8XXX
       act$ = Right$(whex$,1)
       vx$ = Mid$(whex$,2,1) : vy$ = Mid$(whex$,3,1)
       If act$ = "0" Then
              Print #dev,hexaddr$;": ";whex$;" : V";vx$;" = V";vy$ : Return
       EndIf
       If act$ = "1" Then
              Print #dev,hexaddr$;": ";whex$;" : V";vx$;" = V";vx$;" OR V";vy$ : Return
       EndIf
       If act$ = "2" Then
              Print #dev,hexaddr$;": ";whex$;" : V";vx$;" = V";vx$;" AND V";vy$ : Return
       EndIf
       If act$ = "4" Then
              Print #dev,hexaddr$;": ";whex$;" : V";vx$;" = V";vx$;" + V";vy$ : Return
       EndIf
       If act$ = "5" Then
              Print #dev,hexaddr$;": ";whex$;" : V";vx$;" = V";vx$;" - V";vy$ : Return
       EndIf
       Print #dev,hexaddr$;": ";whex$;" : Unknown code" : Return
nine: Rem 9XXX
       vx$ = Mid$(whex$,2,1) : vy$ = Mid$(whex$,3,1)
       Print #dev,hexaddr$;": ";whex$;" : SKF V";vx$;" <> V";vy$
       Return
ten: Rem AMMM
       MMM$ = Right$(whex$,3)
       Print #dev,hexaddr$;": ";whex$;" : I = $";MMM$
       Return
eleven: Rem BMMM
       MMM$ = Right$(whex$,3)
       Print #dev,hexaddr$;": ";whex$;" : GOTO $";MMM$;" + V0"
       Return
twelve: Rem CXXX
       vx$ = Mid$(whex$,2,1) : kk$ = Right$(whex$,2)
       Print #dev,hexaddr$;": ";whex$;" : V";vx$;" = RND AND $";kk$
       Return
thirteen: Rem DXYN
       vx$ = Mid$(whex$,2,1) : vy$ = Mid$(whex$,3,1) : n$ = Right$(whex$,1)
       Print #dev,hexaddr$;": ";whex$;" : SHOW ";n$;" @ V";vx$;", V";vy$
       Return
fourteen: Rem EXXX
       vx$ = Mid$(whex$,2,1) : ex$=Right$(whex$,2)
       If ex$ <> "9E" And ex$ <> "A1" Then
               Print #dev,hexaddr$;": ";whex$;" : unknown code" : Return
       EndIf
       If ex$ = "9E" Then ne$ = " = "
       If ex$ = "A1" Then ne$ = " <> "
       Print #dev,hexaddr$;": ";whex$;" : SKF V";vx$;ne$;"KEY"
       Return
fifteen: Rem FXXX
       act$ = Right$(whex$,2) : vx$ = Mid$(whex$,2,1)
       If act$ = "00" And vx$ = "0" Then
              Print #dev,hexaddr$;": ";whex$;" : STOP"
       EndIf
       If act$ = "07" Then
              Print #dev,hexaddr$;": ";whex$;" : V";vx$;" = TIME" : Return
       EndIf
       If act$ = "0A" Then
              Print #dev,hexaddr$;": ";whex$;" : V";vx$;" = KEY" : Return
       EndIf
       If act$ = "15" Then
              Print #dev,hexaddr$;": ";whex$;" : TIME = V";vx$ : Return
       EndIf
       If act$ = "18" Then
              Print #dev,hexaddr$;": ";whex$;" : TONE = V";vx$ : Return
       EndIf
       If act$ = "1E" Then
              Print #dev,hexaddr$;": ";whex$;" : I = I + V";vx$ : Return
       EndIf
       If act$ = "29" Then
              Print #dev,hexaddr$;": ";whex$;" : I = DSP, V";vx$ : Return
       EndIf
       If act$ = "33" Then
              Print #dev,hexaddr$;": ";whex$;" : MI = DEQ, V";vx$ : Return
       EndIf
       If act$ = "55" Then
              Print #dev,hexaddr$;": ";whex$;" : MI = V0:V";vx$ : Return
       EndIf
       If act$ = "65" Then
              Print #dev,hexaddr$;": ";whex$;" : V0:V";vx$;" = MI" : Return
       EndIf
       Print #dev,hexaddr$;": ";whex$;" : Unknown code" : Return
End
